class TwitterClient
  def initialize(twitter_config)
    @rest_client = Twitter::REST::Client.new do |config|
      config.consumer_key = twitter_config.consumer_key
      config.consumer_secret = twitter_config.consumer_secret
      config.access_token = twitter_config.access_token
      config.access_token_secret = twitter_config.access_token_secret
    end
    @username = twitter_config.username
  end

  def random_follower_of_random_follower
    follower = @rest_client.followers.attrs[:users].sample[:screen_name]
    @rest_client.friend_ids(follower).attrs[:ids].sample if follower
  end

  def update_with_media(text, image_file)
    @rest_client.update_with_media(text, image_file)
  end

  def update(text)
    @rest_client.update(text)
  end

  def search(query)
    @rest_client.search("#{query} -rt -from:#{@username}", { lang: 'en' }).first.text
  end

  def follow(user)
    @rest_client.follow(user)
  end
end
