class TweetFinder
  def initialize(client, topics)
    @client = client
    @topics = topics
  end

  def find_tweets
    @topics.reduce([]) do |t, topic|
      t << Thread.new(topic) { |topic| find_tweet(topic) }
    end.each { |t| t.join }.map { |t| t.value }
  end

  def find_tweet(query)
    @client.search(query)
  end
end
