class Tweet
  attr_accessor :hashtags

  def initialize(text, hashtags, twitter_client)
    @text = text
    @hashtags = hashtags
    @twitter_client = twitter_client
  end

  def post!(image = '')
    if image.length > 0 && File.exists?(image)
      @twitter_client.update_with_media(self.with_hashtags, File.new(image))
      File.delete(image)
    else
      @twitter_client.update(self.with_hashtags)
    end
  end

  def with_hashtags
    (@hashtags && @hashtags.size > 0) ? "#{@text}#{hashtags.reduce('') { |str, h| str << " ##{h}" }}" : @text
  end

  def length
    with_hashtags.length
  end

  def append(text)
    @text << ' ' << text
  end
end
